<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class adminmanagefeatureicon {
    private $lang;
    private $form_message;
    private $form_status;
    private $form_style;
    private $list;
    
    /**
     * Constructor
     * <br>---------------------------------------------------------------------
     */
    public function adminmanagefeatureicon($lang=array()){
        $this->lang = $lang;
        
        // handle upload icon form.
        if( isset($_POST['uploadbtn']) ){
            $this->handleUploadForm();
        }
        
        // handle update form.
        if( isset($_POST['upbtn']) ){
            $this->handleUpdateForm();
        }
        
        // handle delete form.
        if( isset($_POST['delbtn']) ){
            $this->handleRemoveForm();
        }
        
        // load icon list.
        $this->loadIconList();
    }
    
    /**
     * Private method: handle delete icon
     * <br>---------------------------------------------------------------------
     * @return void
     */
    private function handleRemoveForm(){
        $id = (int)$_POST['iid'];
        $src = trim($_POST['fnameInput']);
        
        if( $id < 1 ){
            return;
        }
        
        require_once BASE_CLASS . 'class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !@mysql_query("DELETE FROM `feature_list` WHERE `id`='$id' LIMIT 1;") ){
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write('Unable to remove feature icon due a query error at ' . __FILE__ . ':' . __LINE__);
            $cnx->close();
            $this->form_message = $this->lang['FEATURED_REMOVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        $cnx->close();
        
        if( file_exists(BASE_ROOT . $src) ){
            @unlink(BASE_ROOT . $src);
        }
        
        $this->form_message = $this->lang['FEATURED_REMOVE_QUERY_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /**
     * Private method: handle update form.
     * <br>---------------------------------------------------------------------
     * @return void
     */
    private function handleUpdateForm(){
        $id = (int)$_POST['iid'];
        $label = trim($_POST['ufeatInput']);
        $label = stripslashes($label);
        
        if( $id < 1 ){
            return;
        }
        
        if( empty($label) ){
            $label = $this->lang['FEATURED_UNTITLED_LABEL'];
        }
        
        require_once BASE_CLASS . 'class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        $label = @mysql_real_escape_string($label);
        
        if( !@mysql_query("UPDATE `feature_list` SET `label`='$label' WHERE `id`='$id' LIMIT 1;") ){
            require_once BASE_CLASS . 'class-log.php';
            $cnx->close();
            LogReport::write('Unable to update feature_list table due a query error at ' . __FILE__ . ':' . __LINE__);
            $this->form_message = $this->lang['FEATURED_UPDATE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        $cnx->close();
        $this->form_message = $this->lang['FEATURED_UPDATE_QUERY_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /**
     * Private method: handle upload feature icon
     * <br>---------------------------------------------------------------------
     * @return void.
     */
    private function handleUploadForm(){
        $label = trim($_POST['featInput']);
        $fname = $_FILES['fileInput']['name'];
        
        $label = stripslashes($label);
        $ext = explode('.',$fname);
        $ext = $ext[(count($ext)-1)];
        $ext = strtolower($ext);
        
        // validate.
        if( empty($label) ){
            $this->form_message = $this->lang['FEATURED_INVALID_LABEL'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            return;
        }
        
        switch($ext){
            case 'jpg':
            case 'gif':
            case 'png':
                break;
            default:
                $this->form_message = $this->lang['FEATURED_INVALID_IMAGE_ERROR'];
                $this->form_status = true;
                $this->form_style = 'alert-error';
                return;
        }
        
        // upload file.
        require_once BASE_CLASS . 'class-utilities.php';
        
        $filename = Utilities::genetateSlug($label);
        if( file_exists(BASE_ROOT . 'image/feature_icons/' . $filename  . '.' . $ext) ){
            $filename .= '_' . mt_rand('0000', '9999');
        }
        
        $filename .= '.' . $ext;
        $dest = BASE_ROOT . 'image/feature_icons/' . $filename;
        
        if( !@move_uploaded_file($_FILES['fileInput']['tmp_name'], $dest) ){
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write('Unable to upload featured icon due an error at ' . __FILE__ . ':' . __LINE__);
            $this->form_message = $this->lang['FEATURED_UPLOAD_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        // save icon.
        require_once BASE_CLASS . 'class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        $label = @mysql_real_escape_string($label);
        $source = 'image/feature_icons/' . $filename;
        
        if( !@mysql_query("INSERT INTO `feature_list` (`label`,`source`) VALUES ('$label','$source')") ){
            $cnx->close();
            
            require_once BASE_CLASS . 'class-log.php';
            LogReport::write('Unable to save featured icon due a query error at ' . __FILE__ . ':' . __LINE__);
            
            $this->form_message = $this->lang['FEATURED_UPLOAD_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            
            @unlink($dest);
            
            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['FEATURED_UPLOAD_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        return;
    }
    
    /**
     * Private method: load icon list
     * <br>---------------------------------------------------------------------
     * @return void
     */
    private function loadIconList(){
        require_once BASE_CLASS . 'class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !$sql = @mysql_query("SELECT * FROM `feature_list` ORDER BY `label` ASC") ){
            require_once BASE_CLASS . 'class-log.php';
            $cnx->close();
            LogReport::write('Unable to load feature list due a query error at ' . __FILE__ . ':' . __LINE__);
            $this->form_message = $this->lang['FEATURED_LOAD_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-warning';
            return;
        }
        
        $this->list = array();
                
        if( @mysql_num_rows($sql) < 1 ){
            $cnx->close();
            return;
        }
        
        while( $r = @mysql_fetch_assoc($sql) ){
            $obj = array(
                'id' => $r['id'],
                'label' => stripslashes($r['label']),
                'source' => $r['source']
            );
            array_push($this->list,$obj);
        }
        
        @mysql_free_result($sql);
        $cnx->close();
    }

    /**
     * Public method: get icon list
     * <br>---------------------------------------------------------------------
     * @return array
     */
    public function getIconList(){
        return $this->list;
    }
    
    /**
     * Public method: get form status
     * <br>---------------------------------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }

    /**
     * Public method: get form message 
     * <br>---------------------------------------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }

    /**
     * Public method: get form style
     * <br>---------------------------------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
}