<?php
################################################################################
### This disclaimer must be kept intact in order to use this product.        ###
################################################################################
### Project: jT CarFramework [http://intersofts.com]
### Author: J. Toshio Taniguchi
### Since: 27.04.2011
### Version: 1.0.0
### Copyrights: J. Toshio Taniguchi
### Contact: j.taniguchi@taniguchi-blog.com
################################################################################
### CONTRIBUTORS
### - none
################################################################################
class adminnewpage 
{
    private $lang;
    protected $form_status;
    protected $form_message;
    protected $form_style;
    
    
    
    /*
     * Constructor -------------------------------------------------------------
     */
    public function adminnewpage($lang=array())
    {
        $this->lang = $lang;
        
        // handle save new page form.
        if( isset($_POST['saveBtn']) )
        {
            $this->handleSavePageForm();
        }
    }
    
    /*
     * Private method: handle save page form -----------------------------------
     */
    private function handleSavePageForm()
    {
        $title      = trim($_POST['titleInput']);
        $publish    = trim($_POST['publishInput']);
        $group      = trim($_POST['groupInput']); 
        $keyword    = trim($_POST['keyInput']); 
        $description = trim($_POST['descriptionInput']); 
        $robots     = trim($_POST['robotsInput']); 
        $author     = trim($_POST['authorInput']); 
        $html       = trim($_POST['htmlInput']); 
        $creation   = date('Y-m-d');
        $enabled    = '1';
        
        // validate entries.
        if(strlen($title) < 5 )
        {
            $this->form_message = $this->lang['CMS_NEW_TITLE_LABEL_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            return;
        }
        
        $publish = (bool)$publish;
        ( $publish ? $publish = '1' : $publish = '0' );
        
        $group_valid = false;
        if( $group == 'admin' || $group == 'public' )
        {
            $group_valid = true;
        }
        else
        {
            $glist = $this->getGroupList();
            
            for( $i=0; $i < count($glist); $i++ )
            {
                if( $glist[$i] == $group )
                {
                    $group_valid = true;
                    break;
                }
            }
            
            if( !$group_valid )
            {
                $this->form_message = $this->lang['CMS_NEW_GROUP_LABEL_ERROR'];
                $this->form_status = true;
                $this->form_style = 'alert-error';
                
                return;
            }
        }
        
        switch($robots)
        {
            case 'index,follow':
            case 'index,nofollow':
            case 'noindex,follow':
            case 'noindex,nofollow':
                break;
            default: $robots = 'noindex,nofollow';
        }
        
        // generate page slug based on page title.
        require_once BASE_ROOT . 'core/class-utilities.php';
        
        $slug = Utilities::genetateSlug($title);
        
        // make sure the page is unique. also, validate static pages (home,404,contact)
        if( file_exists(BASE_ROOT . 'view/page/' . $group . '-' . $slug . '.php') || $slug == 'home' || $slug == '404' || $slug == 'contact' )
        {
            $slug .= mt_rand('000','999');
        }
        
        // filter inputs for database.
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        $title = mysql_real_escape_string($title);
        $keyword    = mysql_real_escape_string($keyword); 
        $description = mysql_real_escape_string($description);
        $author     = mysql_real_escape_string($author);
        
        // create page.
        $page_name = $group . '-' . $slug;
        $page_url  = BASE_ROOT . 'view/page/' . $page_name . '.php';
        $page_data = $this->getPageContent($group,$slug);
        
        if( !$fo = @fopen($page_url,'w') )
        {
            $cnx->close();
            
            $this->form_message = $this->lang['CMS_NEW_FOPEN_PAGE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open page directory fopen() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        if( !fwrite($fo, $page_data) )
        {
            $cnx->close();
            @fclose($fo);
            
            $this->form_message = $this->lang['CMS_NEW_FWRITE_PAGE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open page directory fopen() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        @fclose($fo);
        
        // create controller.
        $contr_name = $page_name;
        $contr_url  = BASE_ROOT . 'controller/' . $contr_name . '.php';
        $contr_data = $this->getControllerContent($group, $slug);
        
        if( !$fo = @fopen($contr_url,'w') )
        {
            $cnx->close();
            @unlink($page_url);
            
            $this->form_message = $this->lang['CMS_NEW_CONTROLLER_FOPEN_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open controller directory fopen() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        if( !@fwrite($fo, $contr_data) )
        {
            $cnx->close();
            @fclose($fo);
            @unlink($page_url);
            
            $this->form_message = $this->lang['CMS_NEW_CONTROLLER_FWRITE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open controller directory fwrite() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        @fclose($fo);
        
        // create css.
        $css_url = BASE_ROOT . 'view/theme/'.$_SESSION['CURRENT_THEME'].'/css/' . $page_name . '.css';
        
        if( !$fo = @fopen($css_url,'w') )
        {
            $cnx->close();
            @unlink($page_url);
            @unlink($contr_url);
            
            $this->form_message = $this->lang['CMS_NEW_CSS_FOPEN_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open css directory fopen() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        if( !@fwrite($fo, 'root { display:block; }') )
        {
            $cnx->close();
            @fclose($fo);
            @unlink($page_url);
            @unlink($contr_url);
            
            $this->form_message = $this->lang['CMS_NEW_CSS_FWRITE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open css directory fwrite() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        @fclose($fo);
        
        // create js.
        $js_url = BASE_ROOT . 'view/theme/'.$_SESSION['CURRENT_THEME'].'/js/' . $page_name . '.js';
        
        if( !$fo = @fopen($js_url,'w') )
        {
            $cnx->close();
            @unlink($page_url);
            @unlink($contr_url);
            @unlink($css_url);
            
            $this->form_message = $this->lang['CMS_NEW_JS_FOPEN_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open js directory fopen() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        if( !@fwrite($fo, '/* javascript */') )
        {
            $cnx->close();
            @fclose($fo);
            @unlink($page_url);
            @unlink($contr_url);
            @unlink($css_url);
            
            $this->form_message = $this->lang['CMS_NEW_JS_FWRITE_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to open js directory fwrite() at ' . __FILE__ . ':' . __LINE__ . '. Read permission denied.');

            return;
        }
        
        @fclose($fo);
        
        // register to database.
        if( !mysql_query("INSERT INTO `page` (
                            `meta_keywords`,
                            `meta_description`,
                            `meta_robots`,
                            `page_title`,
                            `page_slug`,
                            `page_publish`,
                            `page_author`,
                            `creation`,
                            `editable`,
                            `page_group`,
                            `html`
                         ) VALUES (
                            '$keyword',
                            '$description',
                            '$robots',
                            '$title',
                            '$slug',
                            '$publish',
                            '$author',
                            '$creation',
                            '$enabled',
                            '$group',
                            '$html'
                         )") )
        {
            $cnx->close();
            @unlink($page_url);
            @unlink($contr_url);
            @unlink($css_url);
            @unlink($js_url);
            
            $this->form_message = $this->lang['CMS_NEW_SAVE_QUERY_ERROR'];
            $this->form_status = true;
            $this->form_style = 'alert-error';
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to query database to save page data at ' . __FILE__ . ':' . __LINE__ . '. ' . mysql_error());

            return;
        }
        
        $cnx->close();
        
        $this->form_message = $this->lang['CMS_NEW_SAVE_SUCCESS'];
        $this->form_status = true;
        $this->form_style = 'alert-success';
        
        return;
    }
    
    /*
     * Private method: get page controller content by group --------------------
     * @return string.
     */
    private function getControllerContent($group,$slug)
    {
        $contr  = '<?php' . "\r\n";
        $contr .= '/*' . "\r\n";
        $contr .= ' *' . "\r\n";
        $contr .= ' * @author Zerotrade' . "\r\n";
        $contr .= ' */' . "\r\n";
        $contr .= 'class ' . $group . str_replace('-','',$slug) . ' ' . "\r\n";
        $contr .= '{' . "\r\n";
        $contr .= '    protected $lang;' . "\r\n";
        $contr .= '    protected $group = \''.$group.'\';' . "\r\n";
        $contr .= '    protected $slug = \''.$slug.'\';' . "\r\n";
        $contr .= '    protected $form_status;' . "\r\n";
        $contr .= '    protected $form_message;' . "\r\n";
        $contr .= '    protected $form_style;' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '    /*' . "\r\n";
        $contr .= '     * Constructor -------------------------------------------------------------' . "\r\n";
        $contr .= '     */' . "\r\n";
        $contr .= '    public function ' . $group . str_replace('-','',$slug) . '($lang=array())' . "\r\n";
        $contr .= '    {' . "\r\n";
        $contr .= '        $this->lang = $lang;' . "\r\n";
        $contr .= '    }' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '    /*' . "\r\n";
        $contr .= '     * Public method: get page content data ------------------------------------' . "\r\n";
        $contr .= '     * @return array | false.' . "\r\n";
        $contr .= '     */' . "\r\n";
        $contr .= '    public function getPageHTML()' . "\r\n";
        $contr .= '    {' . "\r\n";
        $contr .= '        require_once BASE_ROOT . \'core/class-connect.php\';' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '        $cnx = new Connect();' . "\r\n";
        $contr .= '        $cnx->open();' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '        if( !$sql = @mysql_query("SELECT * FROM `page` WHERE `page_slug`=\'$this->slug\' AND `page_group`=\'$this->group\' LIMIT 1;") )' . "\r\n";
        $contr .= '        {' . "\r\n";
        $contr .= '            $cnx->close();' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            require_once BASE_ROOT . \'core/class-log.php\';' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            LogReport::write(\'Unable to load page information at \' . __FILE__ . \':\' . __LINE__ . \'. \' . mysql_error());' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            $this->form_message = \'Unable to load page content due an internal error.\';' . "\r\n";
        $contr .= '            $this->form_status = true;' . "\r\n";
        $contr .= '            $this->form_style = \'alert-error\';' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            return;' . "\r\n";
        $contr .= '        }' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '        if( @mysql_num_rows($sql) != 1 )' . "\r\n";
        $contr .= '        {' . "\r\n";
        $contr .= '            $cnx->close();' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            require_once BASE_ROOT . \'core/class-log.php\';' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            LogReport::write(\'Unable to load page information at \' . __FILE__ . \':\' . __LINE__ . \'. \' . mysql_error());' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            $this->form_message = \'Unable to load page content due an internal error.\';' . "\r\n";
        $contr .= '            $this->form_status = true;' . "\r\n";
        $contr .= '            $this->form_style = \'alert-error\';' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '            return;' . "\r\n";
        $contr .= '        }' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '        $r = @mysql_fetch_assoc($sql);' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '        $result                     = array();' . "\r\n";
        $contr .= '        $result[\'id\']               = $r[\'id\'];' . "\r\n";
        $contr .= '        $result[\'meta_keywords\']    = $r[\'meta_keywords\'];' . "\r\n";
        $contr .= '        $result[\'meta_description\'] = $r[\'meta_description\'];' . "\r\n";
        $contr .= '        $result[\'meta_robots\']      = $r[\'meta_robots\'];' . "\r\n";
        $contr .= '        $result[\'page_title\']       = $r[\'page_title\'];' . "\r\n";
        $contr .= '        $result[\'page_slug\']        = $r[\'page_slug\'];' . "\r\n";
        $contr .= '        $result[\'page_publish\']     = $r[\'page_publish\'];' . "\r\n";
        $contr .= '        $result[\'page_author\']      = $r[\'page_author\'];' . "\r\n";
        $contr .= '        $result[\'creation\']         = $r[\'creation\'];' . "\r\n";
        $contr .= '        $result[\'editable\']         = $r[\'editable\'];' . "\r\n";
        $contr .= '        $result[\'page_group\']       = $r[\'page_group\'];' . "\r\n";
        $contr .= '        $result[\'html\']             = $r[\'html\'];' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '        @mysql_free_result($sql);' . "\r\n";
        $contr .= '        $cnx->close();' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '        return $result;' . "\r\n";
        $contr .= '    }' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '    /*' . "\r\n";
        $contr .= '     * Public method: get form status ------------------------------------------' . "\r\n";
        $contr .= '     * @return bool.' . "\r\n";
        $contr .= '     */' . "\r\n";
        $contr .= '    public function getFormStatus()' . "\r\n";
        $contr .= '    {' . "\r\n";
        $contr .= '        return $this->form_status;' . "\r\n";
        $contr .= '    }' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '    /*' . "\r\n";
        $contr .= '     * Public method: get form message -----------------------------------------' . "\r\n";
        $contr .= '     * @return string.' . "\r\n";
        $contr .= '     */' . "\r\n";
        $contr .= '    public function getFormMessage()' . "\r\n";
        $contr .= '    {' . "\r\n";
        $contr .= '        return $this->form_message;' . "\r\n";
        $contr .= '    }' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '    /*' . "\r\n";
        $contr .= '     * Public method: get form style -------------------------------------------' . "\r\n";
        $contr .= '     * @return string.' . "\r\n";
        $contr .= '     */' . "\r\n";
        $contr .= '    public function getFormStyle()' . "\r\n";
        $contr .= '    {' . "\r\n";
        $contr .= '        return $this->form_style;' . "\r\n";
        $contr .= '    }' . "\r\n";
        $contr .= '' . "\r\n";
        $contr .= '}' . "\r\n";
        $contr .= '?>' . "\r\n";
        
        return $contr;
    }
    
    /*
     * Private method: get page content by group -------------------------------
     * @return string.
     */
    private function getPageContent($group,$slug)
    {
        $page = '';
        
        if( $group == 'public' )
        {
            $page .= '<?php' . "\r\n";
            $page .= '/*' . "\r\n";
            $page .= ' * If you need to use CKEditor in this page, make sure to set the controller' . "\r\n";
            $page .= ' * variable to TRUE and set it\'s ID. Otherwise, just leave it at FALSE.' . "\r\n";
            $page .= ' */' . "\r\n";
            $page .= '$_CKEDITOR_ENABLED = false;' . "\r\n";
            $page .= '$_CKEDITOR_ID = \'\';' . "\r\n";
            $page .= '// get form feed.' . "\r\n";
            $page .= '$fstatus = $_CLASS->getFormStatus();' . "\r\n";
            $page .= '$fmessage = $_CLASS->getFormMessage();' . "\r\n";
            $page .= '$fstyle = $_CLASS->getFormStyle();' . "\r\n";
            $page .= '$group = \'public\';' . "\r\n";
            $page .= '$slug  = \''.$slug.'\';' . "\r\n";  
            $page .= '// load page content.' . "\r\n";
            $page .= '$pg_details = $_CLASS->getPageHTML();' . "\r\n";          
            $page .= '?>' . "\r\n";
            $page .= '        <div id="content-wrapper">' . "\r\n";
            $page .= '            <div id="vertical-menu">' . "\r\n";
            $page .= '                <?php $_MENU->loadMenu($_GLANG); ?>' . "\r\n";
            $page .= '            </div>' . "\r\n";
            $page .= '            <div id="inner-content">' . "\r\n";
            $page .= '                <!-- START CONTENT -->' . "\r\n";
            $page .= '                <?php' . "\r\n";
            $page .= '                    if( $fstatus ){' . "\r\n";
            $page .= '                ?>' . "\r\n";
            $page .= '                <div class="alert <?php echo $fstyle;?>">' . "\r\n";
            $page .= '                    <button type="button" class="close" data-dismiss="alert">×</button>' . "\r\n";
            $page .= '                    <?php echo $fmessage;?>' . "\r\n";
            $page .= '                </div>' . "\r\n";
            $page .= '                <?php' . "\r\n";
            $page .= '                    }' . "\r\n";
            $page .= '                    else' . "\r\n";
            $page .= '                    {' . "\r\n";
            $page .= '                        echo $pg_details[\'html\'];' . "\r\n";
            $page .= '                    }' . "\r\n";
            $page .= '                ?>' . "\r\n";
            $page .= '                <!-- END CONTENT -->' . "\r\n";
            $page .= '            </div>' . "\r\n";
            $page .= '            <div class="clearfix"></div>' . "\r\n";
            $page .= '        </div>' . "\r\n";
        }
        else if( $page == 'admin' )
        {
            $page .= '<?php' . "\r\n";
            $page .= '/*' . "\r\n";
            $page .= ' * If you need to use CKEditor in this page, make sure to set the controller' . "\r\n";
            $page .= ' * variable to TRUE and set it\'s ID. Otherwise, just leave it at FALSE.' . "\r\n";
            $page .= ' */' . "\r\n";
            $page .= '$_CKEDITOR_ENABLED = false;' . "\r\n";
            $page .= '$_CKEDITOR_ID = \'\';' . "\r\n";
            $page .= '/*' . "\r\n";
            $page .= ' * VALIDATE ADMINISTRATOR GROUP ------------------------------------------------' . "\r\n";
            $page .= ' */' . "\r\n";
            $page .= 'if( $_SESSION[\'log_group\'] == \'admin\' )' . "\r\n";
            $page .= '{' . "\r\n";
            $page .= '    $group = \'admin\';' . "\r\n";
            $page .= '    $slug  = \''.$slug.'\';' . "\r\n";
            $page .= '' . "\r\n";
            $page .= '    // get form feed.' . "\r\n";
            $page .= '    $fstatus = $_CLASS->getFormStatus();' . "\r\n";
            $page .= '    $fmessage = $_CLASS->getFormMessage();' . "\r\n";
            $page .= '    $fstyle = $_CLASS->getFormStyle();' . "\r\n";
            $page .= '' . "\r\n";
            $page .= '    // load page content.' . "\r\n";
            $page .= '    $pg_details = $_CLASS->getPageHTML();' . "\r\n";
            $page .= '?>' . "\r\n";
            $page .= '        <div id="content-wrapper">' . "\r\n";
            $page .= '            <div id="vertical-menu">' . "\r\n";
            $page .= '                <?php $_MENU->loadMenu($_GLANG); ?>' . "\r\n";
            $page .= '            </div>' . "\r\n";
            $page .= '            <div id="inner-content">' . "\r\n";
            $page .= '                <!-- START CONTENT -->' . "\r\n";
            $page .= '                <?php' . "\r\n";
            $page .= '                    if( $fstatus ){' . "\r\n";
            $page .= '                ?>' . "\r\n";
            $page .= '                <div class="alert <?php echo $fstyle;?>">' . "\r\n";
            $page .= '                    <button type="button" class="close" data-dismiss="alert">×</button>' . "\r\n";
            $page .= '                    <?php echo $fmessage;?>' . "\r\n";
            $page .= '               </div>' . "\r\n";
            $page .= '                <?php' . "\r\n";
            $page .= '                    }' . "\r\n";
            $page .= '                    else' . "\r\n";
            $page .= '                    {' . "\r\n";
            $page .= '                        echo $pg_details[\'html\'];' . "\r\n";
            $page .= '                    }' . "\r\n";
            $page .= '                ?>' . "\r\n";
            $page .= '                <!-- END CONTENT -->' . "\r\n";
            $page .= '            </div>' . "\r\n";
            $page .= '            <div class="clearfix"></div>' . "\r\n";
            $page .= '        </div>' . "\r\n";
            $page .= '<?php' . "\r\n";
            $page .= '} // end validation.' . "\r\n";
            $page .= 'else' . "\r\n";
            $page .= '{' . "\r\n";
            $page .= '?>' . "\r\n";
            $page .= '        <p class="text-warning"><?php echo $_LOCAL[\'UNAUTHORIZED_ACCESS_MESSAGE\'];?></p>' . "\r\n";
            $page .= '<?' . "\r\n";
            $page .= '}' . "\r\n";
        }
        else
        {
            $page .= '<?php' . "\r\n";
            $page .= '/*' . "\r\n";
            $page .= ' * If you need to use CKEditor in this page, make sure to set the controller' . "\r\n";
            $page .= ' * variable to TRUE and set it\'s ID. Otherwise, just leave it at FALSE.' . "\r\n";
            $page .= ' */' . "\r\n";
            $page .= '$_CKEDITOR_ENABLED = false;' . "\r\n";
            $page .= '$_CKEDITOR_ID = \'\';' . "\r\n";
            $page .= '/*' . "\r\n";
            $page .= ' * VALIDATE ADMINISTRATOR GROUP ------------------------------------------------' . "\r\n";
            $page .= ' */' . "\r\n";
            $page .= 'if( isset($_SESSION[\'log_group\']) )' . "\r\n";
            $page .= '{' . "\r\n";
            $page .= '    $group = \''.$group.'\';' . "\r\n";
            $page .= '    $slug  = \''.$slug.'\';' . "\r\n";
            $page .= '' . "\r\n";
            $page .= '    // get form feed.' . "\r\n";
            $page .= '    $fstatus = $_CLASS->getFormStatus();' . "\r\n";
            $page .= '    $fmessage = $_CLASS->getFormMessage();' . "\r\n";
            $page .= '    $fstyle = $_CLASS->getFormStyle();' . "\r\n";
            $page .= '' . "\r\n";
            $page .= '    // load page content.' . "\r\n";
            $page .= '    $pg_details = $_CLASS->getPageHTML();' . "\r\n";
            $page .= '?>' . "\r\n";
            $page .= '        <div id="content-wrapper">' . "\r\n";
            $page .= '            <div id="vertical-menu">' . "\r\n";
            $page .= '                <?php $_MENU->loadMenu($_GLANG); ?>' . "\r\n";
            $page .= '            </div>' . "\r\n";
            $page .= '            <div id="inner-content">' . "\r\n";
            $page .= '                <!-- START CONTENT -->' . "\r\n";
            $page .= '                <?php' . "\r\n";
            $page .= '                    if( $fstatus ){' . "\r\n";
            $page .= '                ?>' . "\r\n";
            $page .= '                <div class="alert <?php echo $fstyle;?>">' . "\r\n";
            $page .= '                    <button type="button" class="close" data-dismiss="alert">×</button>' . "\r\n";
            $page .= '                    <?php echo $fmessage;?>' . "\r\n";
            $page .= '               </div>' . "\r\n";
            $page .= '                <?php' . "\r\n";
            $page .= '                    }' . "\r\n";
            $page .= '                    else' . "\r\n";
            $page .= '                    {' . "\r\n";
            $page .= '                        echo base64_decode($pg_details[\'html\']);' . "\r\n";
            $page .= '                    }' . "\r\n";
            $page .= '                ?>' . "\r\n";
            $page .= '                <!-- END CONTENT -->' . "\r\n";
            $page .= '            </div>' . "\r\n";
            $page .= '            <div class="clearfix"></div>' . "\r\n";
            $page .= '        </div>' . "\r\n";
            $page .= '<?php' . "\r\n";
            $page .= '} // end validation.' . "\r\n";
            $page .= 'else' . "\r\n";
            $page .= '{' . "\r\n";
            $page .= '?>' . "\r\n";
            $page .= '        <p class="text-warning"><?php echo $_LOCAL[\'UNAUTHORIZED_ACCESS_MESSAGE\'];?></p>' . "\r\n";
            $page .= '<?' . "\r\n";
            $page .= '}' . "\r\n";
        }
        
        return $page;
    }
    
    /*
     * Public method: get page group list --------------------------------------
     * @return array | false
     */
    public function getGroupList()
    {
        require_once BASE_ROOT . 'core/class-connect.php';
        
        $cnx = new Connect();
        $cnx->open();
        
        if( !$sql = mysql_query("SELECT * FROM `group`") )
        {
            $cnx->close();
            
            require_once BASE_ROOT . 'core/class-log.php';
            
            LogReport::write('Unable to query group table at ' . __FILE__ . ':' . __LINE__ . '.' . mysql_error());
            LogReport::fatalError('Unable to load group list due an internal error. See log for details.');
        }
        
        if( @mysql_num_rows($sql) < 1 )
        {
            $cnx->close();
            
            return array();
        }
        
        $result = array();
        
        while( $r = mysql_fetch_assoc($sql) )
        {
            array_push($result, $r['group']);
        }
        
        @mysql_free_result($sql);
        
        $cnx->close();
        
        return $result;
    }
    
    /*
     * Public method: get form status ------------------------------------------
     * @return bool.
     */
    public function getFormStatus()
    {
        return $this->form_status;
    }
    
    /*
     * Public method: get form message -----------------------------------------
     * @return string.
     */
    public function getFormMessage()
    {
        return $this->form_message;
    }
    
    /*
     * Public method: get form style -------------------------------------------
     * @return string.
     */
    public function getFormStyle()
    {
        return $this->form_style;
    }
}
